Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Halide::Runtime::Internal::Synchronization::broadcast_parking_control Struct Referencefinal

`#include <synchronization_common.h>`

Inheritance diagram for Halide::Runtime::Internal::Synchronization::broadcast_parking_control:

## Public Member Functions
ALWAYS_INLINE | broadcast_parking_control (uintptr_t *cond_state, fast_mutex *mutex)
Public Member Functions inherited from Halide::Runtime::Internal::Synchronization::parking_control
uintptr_t | park (uintptr_t addr)
uintptr_t | unpark_one (uintptr_t addr)
int | unpark_requeue (uintptr_t addr_from, uintptr_t addr_to, uintptr_t unpark_info)

## Public Attributes
uintptr_t *const | cond_state
fast_mutex *const | mutex

## Protected Member Functions
bool | validate (validate_action &action) final
void | requeue_callback (const validate_action &action, bool one_to_wake, bool some_requeued) final
Protected Member Functions inherited from Halide::Runtime::Internal::Synchronization::parking_control
virtual bool | validate (validate_action &action)
virtual void | before_sleep ()
virtual uintptr_t | unpark (int unparked, bool more_waiters)
virtual void | requeue_callback (const validate_action &action, bool one_to_wake, bool some_requeued)

## Detailed Description

Definition at line 747 of file synchronization_common.h.

## Constructor & Destructor Documentation

## ◆ broadcast_parking_control()

ALWAYS_INLINE Halide::Runtime::Internal::Synchronization::broadcast_parking_control::broadcast_parking_control | ( | uintptr_t * | cond_state,
|  | fast_mutex * | mutex
| ) |  |
| inline

Definition at line 751 of file synchronization_common.h.

## Member Function Documentation

## ◆ validate()

bool Halide::Runtime::Internal::Synchronization::broadcast_parking_control::validate | ( | validate_action & | action | ) |
| inline final protected virtual

Reimplemented from Halide::Runtime::Internal::Synchronization::parking_control.

Definition at line 756 of file synchronization_common.h.

References cond_state, Halide::Runtime::Internal::Synchronization::fast_mutex::make_parked_if_locked(), and mutex.

## ◆ requeue_callback()

void Halide::Runtime::Internal::Synchronization::broadcast_parking_control::requeue_callback | ( | const validate_action & | action,
|  | bool | one_to_wake,
|  | bool | some_requeued
| ) |  |
| inline final protected virtual

Reimplemented from Halide::Runtime::Internal::Synchronization::parking_control.

Definition at line 772 of file synchronization_common.h.

References Halide::Runtime::Internal::Synchronization::fast_mutex::make_parked(), and mutex.

## Member Data Documentation

## ◆ cond_state

uintptr_t* const Halide::Runtime::Internal::Synchronization::broadcast_parking_control::cond_state

Definition at line 748 of file synchronization_common.h.

Referenced by validate().

## ◆ mutex

fast_mutex* const Halide::Runtime::Internal::Synchronization::broadcast_parking_control::mutex

Definition at line 749 of file synchronization_common.h.

Referenced by requeue_callback(), and validate().

The documentation for this struct was generated from the following file:

- src/runtime/synchronization_common.h